# coding: utf-8

"""
    Sonatype Lifecycle Public REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.192.0-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from sonatype_iq_api_client.models.api_license_dto import ApiLicenseDTO
from typing import Optional, Set
from typing_extensions import Self

class ApiLicenseDataDTO(BaseModel):
    """
    ApiLicenseDataDTO
    """ # noqa: E501
    declared_licenses: Optional[List[ApiLicenseDTO]] = Field(default=None, alias="declaredLicenses")
    effective_licenses: Optional[List[ApiLicenseDTO]] = Field(default=None, alias="effectiveLicenses")
    observed_licenses: Optional[List[ApiLicenseDTO]] = Field(default=None, alias="observedLicenses")
    overridden_licenses: Optional[List[ApiLicenseDTO]] = Field(default=None, alias="overriddenLicenses")
    status: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["declaredLicenses", "effectiveLicenses", "observedLicenses", "overriddenLicenses", "status"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ApiLicenseDataDTO from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in declared_licenses (list)
        _items = []
        if self.declared_licenses:
            for _item_declared_licenses in self.declared_licenses:
                if _item_declared_licenses:
                    _items.append(_item_declared_licenses.to_dict())
            _dict['declaredLicenses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in effective_licenses (list)
        _items = []
        if self.effective_licenses:
            for _item_effective_licenses in self.effective_licenses:
                if _item_effective_licenses:
                    _items.append(_item_effective_licenses.to_dict())
            _dict['effectiveLicenses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in observed_licenses (list)
        _items = []
        if self.observed_licenses:
            for _item_observed_licenses in self.observed_licenses:
                if _item_observed_licenses:
                    _items.append(_item_observed_licenses.to_dict())
            _dict['observedLicenses'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in overridden_licenses (list)
        _items = []
        if self.overridden_licenses:
            for _item_overridden_licenses in self.overridden_licenses:
                if _item_overridden_licenses:
                    _items.append(_item_overridden_licenses.to_dict())
            _dict['overriddenLicenses'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ApiLicenseDataDTO from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "declaredLicenses": [ApiLicenseDTO.from_dict(_item) for _item in obj["declaredLicenses"]] if obj.get("declaredLicenses") is not None else None,
            "effectiveLicenses": [ApiLicenseDTO.from_dict(_item) for _item in obj["effectiveLicenses"]] if obj.get("effectiveLicenses") is not None else None,
            "observedLicenses": [ApiLicenseDTO.from_dict(_item) for _item in obj["observedLicenses"]] if obj.get("observedLicenses") is not None else None,
            "overriddenLicenses": [ApiLicenseDTO.from_dict(_item) for _item in obj["overriddenLicenses"]] if obj.get("overriddenLicenses") is not None else None,
            "status": obj.get("status")
        })
        return _obj


