# coding: utf-8

"""
    Sonatype Lifecycle Public REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.192.0-01
    Contact: community@sonatype.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from sonatype_iq_api_client.models.validation_result import ValidationResult
from typing import Optional, Set
from typing_extensions import Self

class ConfigurationValidationResult(BaseModel):
    """
    ConfigurationValidationResult
    """ # noqa: E501
    configuration_complete: Optional[ValidationResult] = Field(default=None, alias="configurationComplete")
    repo_private: Optional[ValidationResult] = Field(default=None, alias="repoPrivate")
    repo_public: Optional[ValidationResult] = Field(default=None, alias="repoPublic")
    ssh_configuration: Optional[ValidationResult] = Field(default=None, alias="sshConfiguration")
    token_permissions: Optional[ValidationResult] = Field(default=None, alias="tokenPermissions")
    __properties: ClassVar[List[str]] = ["configurationComplete", "repoPrivate", "repoPublic", "sshConfiguration", "tokenPermissions"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ConfigurationValidationResult from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of configuration_complete
        if self.configuration_complete:
            _dict['configurationComplete'] = self.configuration_complete.to_dict()
        # override the default output from pydantic by calling `to_dict()` of repo_private
        if self.repo_private:
            _dict['repoPrivate'] = self.repo_private.to_dict()
        # override the default output from pydantic by calling `to_dict()` of repo_public
        if self.repo_public:
            _dict['repoPublic'] = self.repo_public.to_dict()
        # override the default output from pydantic by calling `to_dict()` of ssh_configuration
        if self.ssh_configuration:
            _dict['sshConfiguration'] = self.ssh_configuration.to_dict()
        # override the default output from pydantic by calling `to_dict()` of token_permissions
        if self.token_permissions:
            _dict['tokenPermissions'] = self.token_permissions.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ConfigurationValidationResult from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "configurationComplete": ValidationResult.from_dict(obj["configurationComplete"]) if obj.get("configurationComplete") is not None else None,
            "repoPrivate": ValidationResult.from_dict(obj["repoPrivate"]) if obj.get("repoPrivate") is not None else None,
            "repoPublic": ValidationResult.from_dict(obj["repoPublic"]) if obj.get("repoPublic") is not None else None,
            "sshConfiguration": ValidationResult.from_dict(obj["sshConfiguration"]) if obj.get("sshConfiguration") is not None else None,
            "tokenPermissions": ValidationResult.from_dict(obj["tokenPermissions"]) if obj.get("tokenPermissions") is not None else None
        })
        return _obj


